--- linux-2.6.16-rc1/arch/sparc64/solaris/fs.c	2006-01-26 22:34:49 +0100
+++ linux-2.6.16-rc1-vs2.1.0.9.4/arch/sparc64/solaris/fs.c	2006-01-21 18:28:16 +0100
@@ -363,7 +363,7 @@ static int report_statvfs(struct vfsmoun
 		int j = strlen (p);
 		
 		if (j > 15) j = 15;
-		if (IS_RDONLY(inode)) i = 1;
+		if (IS_RDONLY(inode) || MNT_IS_RDONLY(mnt)) i = 1;
 		if (mnt->mnt_flags & MNT_NOSUID) i |= 2;
 		if (!sysv_valid_dev(inode->i_sb->s_dev))
 			return -EOVERFLOW;
--- linux-2.6.16-rc1/arch/sparc64/solaris/fs.c	2006-01-26 22:34:49 +0100
+++ linux-2.6.16-rc1-vs2.1.0.9.4/arch/sparc64/solaris/fs.c	2006-01-21 18:28:16 +0100
@@ -399,7 +399,7 @@ static int report_statvfs64(struct vfsmo
 		int j = strlen (p);
 		
 		if (j > 15) j = 15;
-		if (IS_RDONLY(inode)) i = 1;
+		if (IS_RDONLY(inode) || MNT_IS_RDONLY(mnt)) i = 1;
 		if (mnt->mnt_flags & MNT_NOSUID) i |= 2;
 		if (!sysv_valid_dev(inode->i_sb->s_dev))
 			return -EOVERFLOW;
--- linux-2.6.16-rc1/fs/ext2/ioctl.c	2006-01-26 22:35:11 +0100
+++ linux-2.6.16-rc1-vs2.1.0.9.4/fs/ext2/ioctl.c	2006-01-21 18:28:16 +0100
@@ -11,6 +11,7 @@
 #include <linux/capability.h>
 #include <linux/time.h>
 #include <linux/sched.h>
+#include <linux/mount.h>
 #include <asm/current.h>
 #include <asm/uaccess.h>
 
--- linux-2.6.16-rc1/fs/ext2/ioctl.c	2006-01-26 22:35:11 +0100
+++ linux-2.6.16-rc1-vs2.1.0.9.4/fs/ext2/ioctl.c	2006-01-21 18:28:16 +0100
@@ -30,7 +31,8 @@ int ext2_ioctl (struct inode * inode, st
 	case EXT2_IOC_SETFLAGS: {
 		unsigned int oldflags;
 
-		if (IS_RDONLY(inode))
+		if (IS_RDONLY(inode) ||
+			(filp && MNT_IS_RDONLY(filp->f_vfsmnt)))
 			return -EROFS;
 
 		if ((current->fsuid != inode->i_uid) && !capable(CAP_FOWNER))
--- linux-2.6.16-rc1/fs/ext2/ioctl.c	2006-01-26 22:35:11 +0100
+++ linux-2.6.16-rc1-vs2.1.0.9.4/fs/ext2/ioctl.c	2006-01-21 18:28:16 +0100
@@ -69,7 +73,8 @@ int ext2_ioctl (struct inode * inode, st
 	case EXT2_IOC_SETVERSION:
 		if ((current->fsuid != inode->i_uid) && !capable(CAP_FOWNER))
 			return -EPERM;
-		if (IS_RDONLY(inode))
+		if (IS_RDONLY(inode) ||
+			(filp && MNT_IS_RDONLY(filp->f_vfsmnt)))
 			return -EROFS;
 		if (get_user(inode->i_generation, (int __user *) arg))
 			return -EFAULT;	
--- linux-2.6.16-rc1/fs/ext3/ioctl.c	2006-01-26 22:35:11 +0100
+++ linux-2.6.16-rc1-vs2.1.0.9.4/fs/ext3/ioctl.c	2006-01-25 05:34:51 +0100
@@ -8,6 +8,7 @@
  */
 
 #include <linux/fs.h>
+#include <linux/mount.h>
 #include <linux/jbd.h>
 #include <linux/capability.h>
 #include <linux/ext3_fs.h>
--- linux-2.6.16-rc1/fs/ext3/ioctl.c	2006-01-26 22:35:11 +0100
+++ linux-2.6.16-rc1-vs2.1.0.9.4/fs/ext3/ioctl.c	2006-01-25 05:34:51 +0100
@@ -36,7 +38,8 @@ int ext3_ioctl (struct inode * inode, st
 		unsigned int oldflags;
 		unsigned int jflag;
 
-		if (IS_RDONLY(inode))
+		if (IS_RDONLY(inode) ||
+			(filp && MNT_IS_RDONLY(filp->f_vfsmnt)))
 			return -EROFS;
 
 		if ((current->fsuid != inode->i_uid) && !capable(CAP_FOWNER))
--- linux-2.6.16-rc1/fs/ext3/ioctl.c	2006-01-26 22:35:11 +0100
+++ linux-2.6.16-rc1-vs2.1.0.9.4/fs/ext3/ioctl.c	2006-01-25 05:34:51 +0100
@@ -112,7 +117,8 @@ flags_err:
 
 		if ((current->fsuid != inode->i_uid) && !capable(CAP_FOWNER))
 			return -EPERM;
-		if (IS_RDONLY(inode))
+		if (IS_RDONLY(inode) ||
+			(filp && MNT_IS_RDONLY(filp->f_vfsmnt)))
 			return -EROFS;
 		if (get_user(generation, (int __user *) arg))
 			return -EFAULT;
--- linux-2.6.16-rc1/fs/ext3/ioctl.c	2006-01-26 22:35:11 +0100
+++ linux-2.6.16-rc1-vs2.1.0.9.4/fs/ext3/ioctl.c	2006-01-25 05:34:51 +0100
@@ -166,7 +172,8 @@ flags_err:
 		if (!test_opt(inode->i_sb, RESERVATION) ||!S_ISREG(inode->i_mode))
 			return -ENOTTY;
 
-		if (IS_RDONLY(inode))
+		if (IS_RDONLY(inode) ||
+			(filp && MNT_IS_RDONLY(filp->f_vfsmnt)))
 			return -EROFS;
 
 		if ((current->fsuid != inode->i_uid) && !capable(CAP_FOWNER))
--- linux-2.6.16-rc1/fs/ext3/ioctl.c	2006-01-26 22:35:11 +0100
+++ linux-2.6.16-rc1-vs2.1.0.9.4/fs/ext3/ioctl.c	2006-01-25 05:34:51 +0100
@@ -201,7 +208,8 @@ flags_err:
 		if (!capable(CAP_SYS_RESOURCE))
 			return -EPERM;
 
-		if (IS_RDONLY(inode))
+		if (IS_RDONLY(inode) ||
+			(filp && MNT_IS_RDONLY(filp->f_vfsmnt)))
 			return -EROFS;
 
 		if (get_user(n_blocks_count, (__u32 __user *)arg))
--- linux-2.6.16-rc1/fs/ext3/ioctl.c	2006-01-26 22:35:11 +0100
+++ linux-2.6.16-rc1-vs2.1.0.9.4/fs/ext3/ioctl.c	2006-01-25 05:34:51 +0100
@@ -222,7 +230,8 @@ flags_err:
 		if (!capable(CAP_SYS_RESOURCE))
 			return -EPERM;
 
-		if (IS_RDONLY(inode))
+		if (IS_RDONLY(inode) ||
+			(filp && MNT_IS_RDONLY(filp->f_vfsmnt)))
 			return -EROFS;
 
 		if (copy_from_user(&input, (struct ext3_new_group_input __user *)arg,
--- linux-2.6.16-rc1/fs/hfsplus/ioctl.c	2006-01-26 22:35:11 +0100
+++ linux-2.6.16-rc1-vs2.1.0.9.4/fs/hfsplus/ioctl.c	2006-01-21 18:28:16 +0100
@@ -35,7 +35,8 @@ int hfsplus_ioctl(struct inode *inode, s
 			flags |= EXT2_FLAG_NODUMP; /* EXT2_NODUMP_FL */
 		return put_user(flags, (int __user *)arg);
 	case HFSPLUS_IOC_EXT2_SETFLAGS: {
-		if (IS_RDONLY(inode))
+		if (IS_RDONLY(inode) ||
+			(filp && MNT_IS_RDONLY(filp->f_vfsmnt)))
 			return -EROFS;
 
 		if ((current->fsuid != inode->i_uid) && !capable(CAP_FOWNER))
--- linux-2.6.16-rc1/fs/namei.c	2006-01-26 22:35:12 +0100
+++ linux-2.6.16-rc1-vs2.1.0.9.4/fs/namei.c	2006-01-25 05:34:51 +0100
@@ -233,7 +255,7 @@ int permission(struct inode *inode, int 
 		/*
 		 * Nobody gets write access to a read-only fs.
 		 */
-		if (IS_RDONLY(inode) &&
+		if ((IS_RDONLY(inode) || (nd && MNT_IS_RDONLY(nd->mnt))) &&
 		    (S_ISREG(mode) || S_ISDIR(mode) || S_ISLNK(mode)))
 			return -EROFS;
 
--- linux-2.6.16-rc1/fs/namei.c	2006-01-26 22:35:12 +0100
+++ linux-2.6.16-rc1-vs2.1.0.9.4/fs/namei.c	2006-01-25 05:34:51 +0100
@@ -1294,7 +1337,8 @@ static inline int check_sticky(struct in
  * 10. We don't allow removal of NFS sillyrenamed files; it's handled by
  *     nfs_async_unlink().
  */
-static int may_delete(struct inode *dir,struct dentry *victim,int isdir)
+static int may_delete(struct inode *dir, struct dentry *victim,
+	int isdir, struct nameidata *nd)
 {
 	int error;
 
--- linux-2.6.16-rc1/fs/namei.c	2006-01-26 22:35:12 +0100
+++ linux-2.6.16-rc1-vs2.1.0.9.4/fs/namei.c	2006-01-25 05:34:51 +0100
@@ -1303,7 +1347,7 @@ static int may_delete(struct inode *dir,
 
 	BUG_ON(victim->d_parent->d_inode != dir);
 
-	error = permission(dir,MAY_WRITE | MAY_EXEC, NULL);
+	error = permission(dir,MAY_WRITE | MAY_EXEC, nd);
 	if (error)
 		return error;
 	if (IS_APPEND(dir))
--- linux-2.6.16-rc1/fs/namei.c	2006-01-26 22:35:12 +0100
+++ linux-2.6.16-rc1-vs2.1.0.9.4/fs/namei.c	2006-01-25 05:34:51 +0100
@@ -1456,7 +1504,8 @@ int may_open(struct nameidata *nd, int a
 			return -EACCES;
 
 		flag &= ~O_TRUNC;
-	} else if (IS_RDONLY(inode) && (flag & FMODE_WRITE))
+	} else if ((IS_RDONLY(inode) || MNT_IS_RDONLY(nd->mnt))
+		&& (flag & FMODE_WRITE))
 		return -EROFS;
 	/*
 	 * An append-only file must be opened in append mode for writing.
--- linux-2.6.16-rc1/fs/namei.c	2006-01-26 22:35:12 +0100
+++ linux-2.6.16-rc1-vs2.1.0.9.4/fs/namei.c	2006-01-25 05:34:51 +0100
@@ -1720,9 +1788,10 @@ fail:
 }
 EXPORT_SYMBOL_GPL(lookup_create);
 
-int vfs_mknod(struct inode *dir, struct dentry *dentry, int mode, dev_t dev)
+int vfs_mknod(struct inode *dir, struct dentry *dentry,
+	int mode, dev_t dev, struct nameidata *nd)
 {
-	int error = may_create(dir, dentry, NULL);
+	int error = may_create(dir, dentry, nd);
 
 	if (error)
 		return error;
--- linux-2.6.16-rc1/fs/namei.c	2006-01-26 22:35:12 +0100
+++ linux-2.6.16-rc1-vs2.1.0.9.4/fs/namei.c	2006-01-25 05:34:51 +0100
@@ -1771,11 +1840,12 @@ asmlinkage long sys_mknod(const char __u
 			error = vfs_create(nd.dentry->d_inode,dentry,mode,&nd);
 			break;
 		case S_IFCHR: case S_IFBLK:
-			error = vfs_mknod(nd.dentry->d_inode,dentry,mode,
-					new_decode_dev(dev));
+			error = vfs_mknod(nd.dentry->d_inode, dentry, mode,
+					new_decode_dev(dev), &nd);
 			break;
 		case S_IFIFO: case S_IFSOCK:
-			error = vfs_mknod(nd.dentry->d_inode,dentry,mode,0);
+			error = vfs_mknod(nd.dentry->d_inode, dentry, mode,
+					0, &nd);
 			break;
 		case S_IFDIR:
 			error = -EPERM;
--- linux-2.6.16-rc1/fs/namei.c	2006-01-26 22:35:12 +0100
+++ linux-2.6.16-rc1-vs2.1.0.9.4/fs/namei.c	2006-01-25 05:34:51 +0100
@@ -1793,9 +1863,10 @@ out:
 	return error;
 }
 
-int vfs_mkdir(struct inode *dir, struct dentry *dentry, int mode)
+int vfs_mkdir(struct inode *dir, struct dentry *dentry,
+	int mode, struct nameidata *nd)
 {
-	int error = may_create(dir, dentry, NULL);
+	int error = may_create(dir, dentry, nd);
 
 	if (error)
 		return error;
--- linux-2.6.16-rc1/fs/namei.c	2006-01-26 22:35:12 +0100
+++ linux-2.6.16-rc1-vs2.1.0.9.4/fs/namei.c	2006-01-25 05:34:51 +0100
@@ -1834,7 +1905,8 @@ asmlinkage long sys_mkdir(const char __u
 		if (!IS_ERR(dentry)) {
 			if (!IS_POSIXACL(nd.dentry->d_inode))
 				mode &= ~current->fs->umask;
-			error = vfs_mkdir(nd.dentry->d_inode, dentry, mode);
+			error = vfs_mkdir(nd.dentry->d_inode, dentry,
+				mode, &nd);
 			dput(dentry);
 		}
 		mutex_unlock(&nd.dentry->d_inode->i_mutex);
--- linux-2.6.16-rc1/fs/namei.c	2006-01-26 22:35:12 +0100
+++ linux-2.6.16-rc1-vs2.1.0.9.4/fs/namei.c	2006-01-25 05:34:51 +0100
@@ -1874,9 +1946,10 @@ void dentry_unhash(struct dentry *dentry
 	spin_unlock(&dcache_lock);
 }
 
-int vfs_rmdir(struct inode *dir, struct dentry *dentry)
+int vfs_rmdir(struct inode *dir, struct dentry *dentry,
+	struct nameidata *nd)
 {
-	int error = may_delete(dir, dentry, 1);
+	int error = may_delete(dir, dentry, 1, nd);
 
 	if (error)
 		return error;
--- linux-2.6.16-rc1/fs/namei.c	2006-01-26 22:35:12 +0100
+++ linux-2.6.16-rc1-vs2.1.0.9.4/fs/namei.c	2006-01-25 05:34:51 +0100
@@ -1937,7 +2010,7 @@ asmlinkage long sys_rmdir(const char __u
 	dentry = lookup_hash(&nd);
 	error = PTR_ERR(dentry);
 	if (!IS_ERR(dentry)) {
-		error = vfs_rmdir(nd.dentry->d_inode, dentry);
+		error = vfs_rmdir(nd.dentry->d_inode, dentry, &nd);
 		dput(dentry);
 	}
 	mutex_unlock(&nd.dentry->d_inode->i_mutex);
--- linux-2.6.16-rc1/fs/namei.c	2006-01-26 22:35:12 +0100
+++ linux-2.6.16-rc1-vs2.1.0.9.4/fs/namei.c	2006-01-25 05:34:51 +0100
@@ -1948,9 +2021,10 @@ exit:
 	return error;
 }
 
-int vfs_unlink(struct inode *dir, struct dentry *dentry)
+int vfs_unlink(struct inode *dir, struct dentry *dentry,
+	struct nameidata *nd)
 {
-	int error = may_delete(dir, dentry, 0);
+	int error = may_delete(dir, dentry, 0, nd);
 
 	if (error)
 		return error;
--- linux-2.6.16-rc1/fs/namei.c	2006-01-26 22:35:12 +0100
+++ linux-2.6.16-rc1-vs2.1.0.9.4/fs/namei.c	2006-01-25 05:34:51 +0100
@@ -2012,7 +2086,7 @@ asmlinkage long sys_unlink(const char __
 		inode = dentry->d_inode;
 		if (inode)
 			atomic_inc(&inode->i_count);
-		error = vfs_unlink(nd.dentry->d_inode, dentry);
+		error = vfs_unlink(nd.dentry->d_inode, dentry, &nd);
 	exit2:
 		dput(dentry);
 	}
--- linux-2.6.16-rc1/fs/namei.c	2006-01-26 22:35:12 +0100
+++ linux-2.6.16-rc1-vs2.1.0.9.4/fs/namei.c	2006-01-25 05:34:51 +0100
@@ -2031,9 +2105,10 @@ slashes:
 	goto exit2;
 }
 
-int vfs_symlink(struct inode *dir, struct dentry *dentry, const char *oldname, int mode)
+int vfs_symlink(struct inode *dir, struct dentry *dentry,
+	const char *oldname, int mode, struct nameidata *nd)
 {
-	int error = may_create(dir, dentry, NULL);
+	int error = may_create(dir, dentry, nd);
 
 	if (error)
 		return error;
--- linux-2.6.16-rc1/fs/namei.c	2006-01-26 22:35:12 +0100
+++ linux-2.6.16-rc1-vs2.1.0.9.4/fs/namei.c	2006-01-25 05:34:51 +0100
@@ -2073,7 +2148,8 @@ asmlinkage long sys_symlink(const char _
 		dentry = lookup_create(&nd, 0);
 		error = PTR_ERR(dentry);
 		if (!IS_ERR(dentry)) {
-			error = vfs_symlink(nd.dentry->d_inode, dentry, from, S_IALLUGO);
+			error = vfs_symlink(nd.dentry->d_inode, dentry,
+				from, S_IALLUGO, &nd);
 			dput(dentry);
 		}
 		mutex_unlock(&nd.dentry->d_inode->i_mutex);
--- linux-2.6.16-rc1/fs/namei.c	2006-01-26 22:35:12 +0100
+++ linux-2.6.16-rc1-vs2.1.0.9.4/fs/namei.c	2006-01-25 05:34:51 +0100
@@ -2085,7 +2161,8 @@ out:
 	return error;
 }
 
-int vfs_link(struct dentry *old_dentry, struct inode *dir, struct dentry *new_dentry)
+int vfs_link(struct dentry *old_dentry, struct inode *dir,
+	struct dentry *new_dentry, struct nameidata *nd)
 {
 	struct inode *inode = old_dentry->d_inode;
 	int error;
--- linux-2.6.16-rc1/fs/namei.c	2006-01-26 22:35:12 +0100
+++ linux-2.6.16-rc1-vs2.1.0.9.4/fs/namei.c	2006-01-25 05:34:51 +0100
@@ -2093,7 +2170,7 @@ int vfs_link(struct dentry *old_dentry, 
 	if (!inode)
 		return -ENOENT;
 
-	error = may_create(dir, new_dentry, NULL);
+	error = may_create(dir, new_dentry, nd);
 	if (error)
 		return error;
 
--- linux-2.6.16-rc1/fs/namei.c	2006-01-26 22:35:12 +0100
+++ linux-2.6.16-rc1-vs2.1.0.9.4/fs/namei.c	2006-01-25 05:34:51 +0100
@@ -2155,7 +2232,8 @@ asmlinkage long sys_link(const char __us
 	new_dentry = lookup_create(&nd, 0);
 	error = PTR_ERR(new_dentry);
 	if (!IS_ERR(new_dentry)) {
-		error = vfs_link(old_nd.dentry, nd.dentry->d_inode, new_dentry);
+		error = vfs_link(old_nd.dentry, nd.dentry->d_inode,
+			new_dentry, &nd);
 		dput(new_dentry);
 	}
 	mutex_unlock(&nd.dentry->d_inode->i_mutex);
--- linux-2.6.16-rc1/fs/namei.c	2006-01-26 22:35:12 +0100
+++ linux-2.6.16-rc1-vs2.1.0.9.4/fs/namei.c	2006-01-25 05:34:51 +0100
@@ -2282,7 +2360,7 @@ int vfs_rename(struct inode *old_dir, st
 	if (old_dentry->d_inode == new_dentry->d_inode)
  		return 0;
  
-	error = may_delete(old_dir, old_dentry, is_dir);
+	error = may_delete(old_dir, old_dentry, is_dir, NULL);
 	if (error)
 		return error;
 
--- linux-2.6.16-rc1/fs/namei.c	2006-01-26 22:35:12 +0100
+++ linux-2.6.16-rc1-vs2.1.0.9.4/fs/namei.c	2006-01-25 05:34:51 +0100
@@ -2289,7 +2367,7 @@ *****
 	if (!new_dentry->d_inode)
 		error = may_create(new_dir, new_dentry, NULL);
 	else
-		error = may_delete(new_dir, new_dentry, is_dir);
+		error = may_delete(new_dir, new_dentry, is_dir, NULL);
 	if (error)
 		return error;
 
--- linux-2.6.16-rc1/fs/namei.c	2006-01-26 22:35:12 +0100
+++ linux-2.6.16-rc1-vs2.1.0.9.4/fs/namei.c	2006-01-25 05:34:51 +0100
@@ -2366,6 +2444,9 @@ static int do_rename(const char * oldnam
 	error = -EINVAL;
 	if (old_dentry == trap)
 		goto exit4;
+	error = -EROFS;
+	if (MNT_IS_RDONLY(newnd.mnt))
+		goto exit4;
 	new_dentry = lookup_hash(&newnd);
 	error = PTR_ERR(new_dentry);
 	if (IS_ERR(new_dentry))
--- linux-2.6.16-rc1/fs/namespace.c	2006-01-26 22:35:12 +0100
+++ linux-2.6.16-rc1-vs2.1.0.9.4/fs/namespace.c	2006-01-25 05:34:51 +0100
@@ -354,38 +383,54 @@ *****
 	struct vfsmount *mnt = v;
 	int err = 0;
 	static struct proc_fs_info {
-		int flag;
-		char *str;
+		int s_flag;
+		int mnt_flag;
+		char *set_str;
+		char *unset_str;
 	} fs_info[] = {
-		{ MS_SYNCHRONOUS, ",sync" },
-		{ MS_DIRSYNC, ",dirsync" },
-		{ MS_MANDLOCK, ",mand" },
-		{ 0, NULL }
-	};
-	static struct proc_fs_info mnt_info[] = {
-		{ MNT_NOSUID, ",nosuid" },
-		{ MNT_NODEV, ",nodev" },
-		{ MNT_NOEXEC, ",noexec" },
-		{ MNT_NOATIME, ",noatime" },
-		{ MNT_NODIRATIME, ",nodiratime" },
-		{ 0, NULL }
+		{ MS_RDONLY, MNT_RDONLY, "ro", "rw" },
+		{ MS_SYNCHRONOUS, 0, ",sync", NULL },
+		{ MS_DIRSYNC, 0, ",dirsync", NULL },
+		{ MS_MANDLOCK, 0, ",mand", NULL },
+		{ MS_TAGGED, 0, ",tag", NULL },
+		{ MS_NOATIME, MNT_NOATIME, ",noatime", NULL },
+		{ MS_NODIRATIME, MNT_NODIRATIME, ",nodiratime", NULL },
+		{ 0, MNT_NOSUID, ",nosuid", NULL },
+		{ 0, MNT_NODEV, ",nodev", NULL },
+		{ 0, MNT_NOEXEC, ",noexec", NULL },
+		{ 0, 0, NULL, NULL }
 	};
-	struct proc_fs_info *fs_infop;
+	struct proc_fs_info *p;
+	unsigned long s_flags = mnt->mnt_sb->s_flags;
+	int mnt_flags = mnt->mnt_flags;
 
-	mangle(m, mnt->mnt_devname ? mnt->mnt_devname : "none");
-	seq_putc(m, ' ');
-	seq_path(m, mnt, mnt->mnt_root, " \t\n\\");
-	seq_putc(m, ' ');
-	mangle(m, mnt->mnt_sb->s_type->name);
-	seq_puts(m, mnt->mnt_sb->s_flags & MS_RDONLY ? " ro" : " rw");
-	for (fs_infop = fs_info; fs_infop->flag; fs_infop++) {
-		if (mnt->mnt_sb->s_flags & fs_infop->flag)
-			seq_puts(m, fs_infop->str);
+	if (vx_flags(VXF_HIDE_MOUNT, 0))
+		return 0;
+	if (!mnt_is_reachable(mnt))
+		return 0;
+
+	if (!vx_check(0, VX_ADMIN|VX_WATCH) &&
+		mnt == current->fs->rootmnt) {
+		seq_puts(m, "/dev/root / ");
+	} else {
+		mangle(m, mnt->mnt_devname ? mnt->mnt_devname : "none");
+		seq_putc(m, ' ');
+		seq_path(m, mnt, mnt->mnt_root, " \t\n\\");
+		seq_putc(m, ' ');
 	}
-	for (fs_infop = mnt_info; fs_infop->flag; fs_infop++) {
-		if (mnt->mnt_flags & fs_infop->flag)
-			seq_puts(m, fs_infop->str);
+	mangle(m, mnt->mnt_sb->s_type->name);
+	seq_putc(m, ' ');
+	for (p = fs_info; (p->s_flag | p->mnt_flag) ; p++) {
+		if ((s_flags & p->s_flag) || (mnt_flags & p->mnt_flag)) {
+			if (p->set_str)
+				seq_puts(m, p->set_str);
+		} else {
+			if (p->unset_str)
+				seq_puts(m, p->unset_str);
+		}
 	}
+	if (mnt->mnt_flags & MNT_TAGID)
+		seq_printf(m, ",tag=%d", mnt->mnt_tag);
 	if (mnt->mnt_sb->s_op->show_options)
 		err = mnt->mnt_sb->s_op->show_options(m, mnt);
 	seq_puts(m, " 0 0\n");
--- linux-2.6.16-rc1/fs/namespace.c	2006-01-26 22:35:12 +0100
+++ linux-2.6.16-rc1-vs2.1.0.9.4/fs/namespace.c	2006-01-25 05:34:51 +0100
@@ -899,6 +977,7 @@ static int do_loopback(struct nameidata 
 		spin_unlock(&vfsmount_lock);
 		release_mounts(&umount_list);
 	}
+	mnt->mnt_flags = mnt_flags;
 
 out:
 	up_write(&namespace_sem);
--- linux-2.6.16-rc1/fs/nfs/dir.c	2006-01-26 22:35:12 +0100
+++ linux-2.6.16-rc1-vs2.1.0.9.4/fs/nfs/dir.c	2006-01-28 03:38:24 +0100
@@ -902,7 +905,8 @@ static int is_atomic_open(struct inode *
 	if (nd->flags & LOOKUP_DIRECTORY)
 		return 0;
 	/* Are we trying to write to a read only partition? */
-	if (IS_RDONLY(dir) && (nd->intent.open.flags & (O_CREAT|O_TRUNC|FMODE_WRITE)))
+	if ((IS_RDONLY(dir) || MNT_IS_RDONLY(nd->mnt)) &&
+		(nd->intent.open.flags & (O_CREAT|O_TRUNC|FMODE_WRITE)))
 		return 0;
 	return 1;
 }
--- linux-2.6.16-rc1/fs/nfsd/nfs4recover.c	2006-01-26 22:35:12 +0100
+++ linux-2.6.16-rc1-vs2.1.0.9.4/fs/nfsd/nfs4recover.c	2006-01-28 03:43:05 +0100
@@ -155,7 +155,7 @@ nfsd4_create_clid_dir(struct nfs4_client
 		dprintk("NFSD: nfsd4_create_clid_dir: DIRECTORY EXISTS\n");
 		goto out_put;
 	}
-	status = vfs_mkdir(rec_dir.dentry->d_inode, dentry, S_IRWXU);
+	status = vfs_mkdir(rec_dir.dentry->d_inode, dentry, S_IRWXU, NULL);
 out_put:
 	dput(dentry);
 out_unlock:
--- linux-2.6.16-rc1/fs/nfsd/nfs4recover.c	2006-01-26 22:35:12 +0100
+++ linux-2.6.16-rc1-vs2.1.0.9.4/fs/nfsd/nfs4recover.c	2006-01-28 03:43:05 +0100
@@ -260,7 +260,7 @@ nfsd4_remove_clid_file(struct dentry *di
 		return -EINVAL;
 	}
 	mutex_lock(&dir->d_inode->i_mutex);
-	status = vfs_unlink(dir->d_inode, dentry);
+	status = vfs_unlink(dir->d_inode, dentry, NULL);
 	mutex_unlock(&dir->d_inode->i_mutex);
 	return status;
 }
--- linux-2.6.16-rc1/fs/nfsd/nfs4recover.c	2006-01-26 22:35:12 +0100
+++ linux-2.6.16-rc1-vs2.1.0.9.4/fs/nfsd/nfs4recover.c	2006-01-28 03:43:05 +0100
@@ -275,7 +275,7 @@ nfsd4_clear_clid_dir(struct dentry *dir,
 	 * a kernel from the future.... */
 	nfsd4_list_rec_dir(dentry, nfsd4_remove_clid_file);
 	mutex_lock(&dir->d_inode->i_mutex);
-	status = vfs_rmdir(dir->d_inode, dentry);
+	status = vfs_rmdir(dir->d_inode, dentry, NULL);
 	mutex_unlock(&dir->d_inode->i_mutex);
 	return status;
 }
--- linux-2.6.16-rc1/fs/nfsd/vfs.c	2006-01-26 22:35:12 +0100
+++ linux-2.6.16-rc1-vs2.1.0.9.4/fs/nfsd/vfs.c	2006-01-21 18:28:17 +0100
@@ -1159,7 +1159,7 @@ nfsd_create(struct svc_rqst *rqstp, stru
 		err = vfs_create(dirp, dchild, iap->ia_mode, NULL);
 		break;
 	case S_IFDIR:
-		err = vfs_mkdir(dirp, dchild, iap->ia_mode);
+		err = vfs_mkdir(dirp, dchild, iap->ia_mode, NULL);
 		break;
 	case S_IFCHR:
 	case S_IFBLK:
--- linux-2.6.16-rc1/fs/nfsd/vfs.c	2006-01-26 22:35:12 +0100
+++ linux-2.6.16-rc1-vs2.1.0.9.4/fs/nfsd/vfs.c	2006-01-21 18:28:17 +0100
@@ -1165,7 +1165,7 @@ *****
 	case S_IFBLK:
 	case S_IFIFO:
 	case S_IFSOCK:
-		err = vfs_mknod(dirp, dchild, iap->ia_mode, rdev);
+		err = vfs_mknod(dirp, dchild, iap->ia_mode, rdev, NULL);
 		break;
 	default:
 	        printk("nfsd: bad file type %o in nfsd_create\n", type);
--- linux-2.6.16-rc1/fs/nfsd/vfs.c	2006-01-26 22:35:12 +0100
+++ linux-2.6.16-rc1-vs2.1.0.9.4/fs/nfsd/vfs.c	2006-01-21 18:28:17 +0100
@@ -1441,7 +1441,8 @@ nfsd_symlink(struct svc_rqst *rqstp, str
 		else {
 			strncpy(path_alloced, path, plen);
 			path_alloced[plen] = 0;
-			err = vfs_symlink(dentry->d_inode, dnew, path_alloced, mode);
+			err = vfs_symlink(dentry->d_inode, dnew,
+				path_alloced, mode, NULL);
 			kfree(path_alloced);
 		}
 	} else
--- linux-2.6.16-rc1/fs/nfsd/vfs.c	2006-01-26 22:35:12 +0100
+++ linux-2.6.16-rc1-vs2.1.0.9.4/fs/nfsd/vfs.c	2006-01-21 18:28:17 +0100
@@ -1445,7 +1446,8 @@ *****
 			kfree(path_alloced);
 		}
 	} else
-		err = vfs_symlink(dentry->d_inode, dnew, path, mode);
+		err = vfs_symlink(dentry->d_inode, dnew,
+			path, mode, NULL);
 
 	if (!err) {
 		if (EX_ISSYNC(fhp->fh_export))
--- linux-2.6.16-rc1/fs/nfsd/vfs.c	2006-01-26 22:35:12 +0100
+++ linux-2.6.16-rc1-vs2.1.0.9.4/fs/nfsd/vfs.c	2006-01-21 18:28:17 +0100
@@ -1503,7 +1505,7 @@ nfsd_link(struct svc_rqst *rqstp, struct
 	dold = tfhp->fh_dentry;
 	dest = dold->d_inode;
 
-	err = vfs_link(dold, dirp, dnew);
+	err = vfs_link(dold, dirp, dnew, NULL);
 	if (!err) {
 		if (EX_ISSYNC(ffhp->fh_export)) {
 			nfsd_sync_dir(ddir);
--- linux-2.6.16-rc1/fs/nfsd/vfs.c	2006-01-26 22:35:12 +0100
+++ linux-2.6.16-rc1-vs2.1.0.9.4/fs/nfsd/vfs.c	2006-01-21 18:28:17 +0100
@@ -1664,9 +1666,9 @@ nfsd_unlink(struct svc_rqst *rqstp, stru
 			err = nfserr_perm;
 		} else
 #endif
-		err = vfs_unlink(dirp, rdentry);
+		err = vfs_unlink(dirp, rdentry, NULL);
 	} else { /* It's RMDIR */
-		err = vfs_rmdir(dirp, rdentry);
+		err = vfs_rmdir(dirp, rdentry, NULL);
 	}
 
 	dput(rdentry);
--- linux-2.6.16-rc1/fs/nfsd/vfs.c	2006-01-26 22:35:12 +0100
+++ linux-2.6.16-rc1-vs2.1.0.9.4/fs/nfsd/vfs.c	2006-01-21 18:28:17 +0100
@@ -1778,7 +1780,8 @@ nfsd_permission(struct svc_export *exp, 
 	 */
 	if (!(acc & MAY_LOCAL_ACCESS))
 		if (acc & (MAY_WRITE | MAY_SATTR | MAY_TRUNC)) {
-			if (EX_RDONLY(exp) || IS_RDONLY(inode))
+			if (EX_RDONLY(exp) || IS_RDONLY(inode)
+				|| MNT_IS_RDONLY(exp->ex_mnt))
 				return nfserr_rofs;
 			if (/* (acc & MAY_WRITE) && */ IS_IMMUTABLE(inode))
 				return nfserr_perm;
--- linux-2.6.16-rc1/fs/open.c	2006-01-26 22:35:12 +0100
+++ linux-2.6.16-rc1-vs2.1.0.9.4/fs/open.c	2006-01-25 05:34:51 +0100
@@ -247,7 +252,7 @@ static long do_sys_truncate(const char _
 		goto dput_and_out;
 
 	error = -EROFS;
-	if (IS_RDONLY(inode))
+	if (IS_RDONLY(inode) || MNT_IS_RDONLY(nd.mnt))
 		goto dput_and_out;
 
 	error = -EPERM;
--- linux-2.6.16-rc1/fs/open.c	2006-01-26 22:35:12 +0100
+++ linux-2.6.16-rc1-vs2.1.0.9.4/fs/open.c	2006-01-25 05:34:51 +0100
@@ -371,7 +376,7 @@ asmlinkage long sys_utime(char __user * 
 	inode = nd.dentry->d_inode;
 
 	error = -EROFS;
-	if (IS_RDONLY(inode))
+	if (IS_RDONLY(inode) || MNT_IS_RDONLY(nd.mnt))
 		goto dput_and_out;
 
 	/* Don't worry, the checks are done in inode_change_ok() */
--- linux-2.6.16-rc1/fs/open.c	2006-01-26 22:35:12 +0100
+++ linux-2.6.16-rc1-vs2.1.0.9.4/fs/open.c	2006-01-25 05:34:51 +0100
@@ -428,7 +433,7 @@ long do_utimes(char __user * filename, s
 	inode = nd.dentry->d_inode;
 
 	error = -EROFS;
-	if (IS_RDONLY(inode))
+	if (IS_RDONLY(inode) || MNT_IS_RDONLY(nd.mnt))
 		goto dput_and_out;
 
 	/* Don't worry, the checks are done in inode_change_ok() */
--- linux-2.6.16-rc1/fs/open.c	2006-01-26 22:35:12 +0100
+++ linux-2.6.16-rc1-vs2.1.0.9.4/fs/open.c	2006-01-25 05:34:51 +0100
@@ -510,7 +515,8 @@ asmlinkage long sys_access(const char __
 	if (!res) {
 		res = vfs_permission(&nd, mode);
 		/* SuS v2 requires we report a read only fs too */
-		if(!res && (mode & S_IWOTH) && IS_RDONLY(nd.dentry->d_inode)
+		if(!res && (mode & S_IWOTH)
+		   && (IS_RDONLY(nd.dentry->d_inode) || MNT_IS_RDONLY(nd.mnt))
 		   && !special_file(nd.dentry->d_inode->i_mode))
 			res = -EROFS;
 		path_release(&nd);
--- linux-2.6.16-rc1/fs/open.c	2006-01-26 22:35:12 +0100
+++ linux-2.6.16-rc1-vs2.1.0.9.4/fs/open.c	2006-01-25 05:34:51 +0100
@@ -616,7 +622,7 @@ asmlinkage long sys_fchmod(unsigned int 
 	inode = dentry->d_inode;
 
 	err = -EROFS;
-	if (IS_RDONLY(inode))
+	if (IS_RDONLY(inode) || MNT_IS_RDONLY(file->f_vfsmnt))
 		goto out_putf;
 	err = -EPERM;
 	if (IS_IMMUTABLE(inode) || IS_APPEND(inode))
--- linux-2.6.16-rc1/fs/open.c	2006-01-26 22:35:12 +0100
+++ linux-2.6.16-rc1-vs2.1.0.9.4/fs/open.c	2006-01-25 05:34:51 +0100
@@ -648,7 +654,7 @@ asmlinkage long sys_chmod(const char __u
 	inode = nd.dentry->d_inode;
 
 	error = -EROFS;
-	if (IS_RDONLY(inode))
+	if (IS_RDONLY(inode) || MNT_IS_RDONLY(nd.mnt))
 		goto dput_and_out;
 
 	error = -EPERM;
--- linux-2.6.16-rc1/fs/open.c	2006-01-26 22:35:12 +0100
+++ linux-2.6.16-rc1-vs2.1.0.9.4/fs/open.c	2006-01-25 05:34:51 +0100
@@ -669,7 +675,8 @@ out:
 	return error;
 }
 
-static int chown_common(struct dentry * dentry, uid_t user, gid_t group)
+static int chown_common(struct dentry *dentry, struct vfsmount *mnt,
+	uid_t user, gid_t group)
 {
 	struct inode * inode;
 	int error;
--- linux-2.6.16-rc1/fs/open.c	2006-01-26 22:35:12 +0100
+++ linux-2.6.16-rc1-vs2.1.0.9.4/fs/open.c	2006-01-25 05:34:51 +0100
@@ -681,7 +688,7 @@ static int chown_common(struct dentry * 
 		goto out;
 	}
 	error = -EROFS;
-	if (IS_RDONLY(inode))
+	if (IS_RDONLY(inode) || MNT_IS_RDONLY(mnt))
 		goto out;
 	error = -EPERM;
 	if (IS_IMMUTABLE(inode) || IS_APPEND(inode))
--- linux-2.6.16-rc1/fs/open.c	2006-01-26 22:35:12 +0100
+++ linux-2.6.16-rc1-vs2.1.0.9.4/fs/open.c	2006-01-25 05:34:51 +0100
@@ -711,7 +718,7 @@ asmlinkage long sys_chown(const char __u
 
 	error = user_path_walk(filename, &nd);
 	if (!error) {
-		error = chown_common(nd.dentry, user, group);
+		error = chown_common(nd.dentry, nd.mnt, user, group);
 		path_release(&nd);
 	}
 	return error;
--- linux-2.6.16-rc1/fs/open.c	2006-01-26 22:35:12 +0100
+++ linux-2.6.16-rc1-vs2.1.0.9.4/fs/open.c	2006-01-25 05:34:51 +0100
@@ -724,7 +731,7 @@ asmlinkage long sys_lchown(const char __
 
 	error = user_path_walk_link(filename, &nd);
 	if (!error) {
-		error = chown_common(nd.dentry, user, group);
+		error = chown_common(nd.dentry, nd.mnt, user, group);
 		path_release(&nd);
 	}
 	return error;
--- linux-2.6.16-rc1/fs/open.c	2006-01-26 22:35:12 +0100
+++ linux-2.6.16-rc1-vs2.1.0.9.4/fs/open.c	2006-01-25 05:34:51 +0100
@@ -738,7 +745,7 @@ asmlinkage long sys_fchown(unsigned int 
 
 	file = fget(fd);
 	if (file) {
-		error = chown_common(file->f_dentry, user, group);
+		error = chown_common(file->f_dentry, file->f_vfsmnt, user, group);
 		fput(file);
 	}
 	return error;
--- linux-2.6.16-rc1/fs/reiserfs/ioctl.c	2006-01-26 22:35:13 +0100
+++ linux-2.6.16-rc1-vs2.1.0.9.4/fs/reiserfs/ioctl.c	2006-01-21 18:28:17 +0100
@@ -4,6 +4,7 @@
 
 #include <linux/capability.h>
 #include <linux/fs.h>
+#include <linux/mount.h>
 #include <linux/reiserfs_fs.h>
 #include <linux/time.h>
 #include <asm/uaccess.h>
--- linux-2.6.16-rc1/fs/reiserfs/ioctl.c	2006-01-26 22:35:13 +0100
+++ linux-2.6.16-rc1-vs2.1.0.9.4/fs/reiserfs/ioctl.c	2006-01-21 18:28:17 +0100
@@ -47,7 +49,8 @@ *****
 			if (!reiserfs_attrs(inode->i_sb))
 				return -ENOTTY;
 
-			if (IS_RDONLY(inode))
+			if (IS_RDONLY(inode) ||
+				(filp && MNT_IS_RDONLY(filp->f_vfsmnt)))
 				return -EROFS;
 
 			if ((current->fsuid != inode->i_uid)
--- linux-2.6.16-rc1/fs/reiserfs/ioctl.c	2006-01-26 22:35:13 +0100
+++ linux-2.6.16-rc1-vs2.1.0.9.4/fs/reiserfs/ioctl.c	2006-01-21 18:28:17 +0100
@@ -82,7 +90,8 @@ int reiserfs_ioctl(struct inode *inode, 
 	case REISERFS_IOC_SETVERSION:
 		if ((current->fsuid != inode->i_uid) && !capable(CAP_FOWNER))
 			return -EPERM;
-		if (IS_RDONLY(inode))
+		if (IS_RDONLY(inode) ||
+			(filp && MNT_IS_RDONLY(filp->f_vfsmnt)))
 			return -EROFS;
 		if (get_user(inode->i_generation, (int __user *)arg))
 			return -EFAULT;
--- linux-2.6.16-rc1/fs/reiserfs/xattr.c	2006-01-26 22:35:13 +0100
+++ linux-2.6.16-rc1-vs2.1.0.9.4/fs/reiserfs/xattr.c	2006-01-21 18:28:17 +0100
@@ -35,6 +35,7 @@
 #include <linux/namei.h>
 #include <linux/errno.h>
 #include <linux/fs.h>
+#include <linux/mount.h>
 #include <linux/file.h>
 #include <linux/pagemap.h>
 #include <linux/xattr.h>
--- linux-2.6.16-rc1/fs/reiserfs/xattr.c	2006-01-26 22:35:13 +0100
+++ linux-2.6.16-rc1-vs2.1.0.9.4/fs/reiserfs/xattr.c	2006-01-21 18:28:17 +0100
@@ -827,7 +828,7 @@ int reiserfs_delete_xattrs(struct inode 
 	if (dir->d_inode->i_nlink <= 2) {
 		root = get_xa_root(inode->i_sb);
 		reiserfs_write_lock_xattrs(inode->i_sb);
-		err = vfs_rmdir(root->d_inode, dir);
+		err = vfs_rmdir(root->d_inode, dir, NULL);
 		reiserfs_write_unlock_xattrs(inode->i_sb);
 		dput(root);
 	} else {
--- linux-2.6.16-rc1/fs/reiserfs/xattr.c	2006-01-26 22:35:13 +0100
+++ linux-2.6.16-rc1-vs2.1.0.9.4/fs/reiserfs/xattr.c	2006-01-21 18:28:17 +0100
@@ -1332,7 +1333,7 @@ __reiserfs_permission(struct inode *inod
 		/*
 		 * Nobody gets write access to a read-only fs.
 		 */
-		if (IS_RDONLY(inode) &&
+		if ((IS_RDONLY(inode) || (nd && MNT_IS_RDONLY(nd->mnt))) &&
 		    (S_ISREG(mode) || S_ISDIR(mode) || S_ISLNK(mode)))
 			return -EROFS;
 
--- linux-2.6.16-rc1/fs/xattr.c	2006-01-26 22:35:13 +0100
+++ linux-2.6.16-rc1-vs2.1.0.9.4/fs/xattr.c	2006-01-21 18:28:17 +0100
@@ -17,6 +17,7 @@
 #include <linux/syscalls.h>
 #include <linux/module.h>
 #include <linux/fsnotify.h>
+#include <linux/mount.h>
 #include <asm/uaccess.h>
 
 
--- linux-2.6.16-rc1/fs/xattr.c	2006-01-26 22:35:13 +0100
+++ linux-2.6.16-rc1-vs2.1.0.9.4/fs/xattr.c	2006-01-21 18:28:17 +0100
@@ -167,7 +168,7 @@ EXPORT_SYMBOL_GPL(vfs_removexattr);
  */
 static long
 setxattr(struct dentry *d, char __user *name, void __user *value,
-	 size_t size, int flags)
+	 size_t size, int flags, struct vfsmount *mnt)
 {
 	int error;
 	void *kvalue = NULL;
--- linux-2.6.16-rc1/fs/xattr.c	2006-01-26 22:35:13 +0100
+++ linux-2.6.16-rc1-vs2.1.0.9.4/fs/xattr.c	2006-01-21 18:28:17 +0100
@@ -194,6 +195,9 @@ setxattr(struct dentry *d, char __user *
 		}
 	}
 
+	if (MNT_IS_RDONLY(mnt))
+		return -EROFS;
+
 	error = vfs_setxattr(d, kname, kvalue, size, flags);
 	kfree(kvalue);
 	return error;
--- linux-2.6.16-rc1/fs/xattr.c	2006-01-26 22:35:13 +0100
+++ linux-2.6.16-rc1-vs2.1.0.9.4/fs/xattr.c	2006-01-21 18:28:17 +0100
@@ -209,7 +213,7 @@ sys_setxattr(char __user *path, char __u
 	error = user_path_walk(path, &nd);
 	if (error)
 		return error;
-	error = setxattr(nd.dentry, name, value, size, flags);
+	error = setxattr(nd.dentry, name, value, size, flags, nd.mnt);
 	path_release(&nd);
 	return error;
 }
--- linux-2.6.16-rc1/fs/xattr.c	2006-01-26 22:35:13 +0100
+++ linux-2.6.16-rc1-vs2.1.0.9.4/fs/xattr.c	2006-01-21 18:28:17 +0100
@@ -224,7 +228,7 @@ sys_lsetxattr(char __user *path, char __
 	error = user_path_walk_link(path, &nd);
 	if (error)
 		return error;
-	error = setxattr(nd.dentry, name, value, size, flags);
+	error = setxattr(nd.dentry, name, value, size, flags, nd.mnt);
 	path_release(&nd);
 	return error;
 }
--- linux-2.6.16-rc1/fs/xattr.c	2006-01-26 22:35:13 +0100
+++ linux-2.6.16-rc1-vs2.1.0.9.4/fs/xattr.c	2006-01-21 18:28:17 +0100
@@ -239,7 +243,7 @@ sys_fsetxattr(int fd, char __user *name,
 	f = fget(fd);
 	if (!f)
 		return error;
-	error = setxattr(f->f_dentry, name, value, size, flags);
+	error = setxattr(f->f_dentry, name, value, size, flags, f->f_vfsmnt);
 	fput(f);
 	return error;
 }
--- linux-2.6.16-rc1/fs/xattr.c	2006-01-26 22:35:13 +0100
+++ linux-2.6.16-rc1-vs2.1.0.9.4/fs/xattr.c	2006-01-21 18:28:17 +0100
@@ -412,7 +416,7 @@ sys_flistxattr(int fd, char __user *list
  * Extended attribute REMOVE operations
  */
 static long
-removexattr(struct dentry *d, char __user *name)
+removexattr(struct dentry *d, char __user *name, struct vfsmount *mnt)
 {
 	int error;
 	char kname[XATTR_NAME_MAX + 1];
--- linux-2.6.16-rc1/fs/xattr.c	2006-01-26 22:35:13 +0100
+++ linux-2.6.16-rc1-vs2.1.0.9.4/fs/xattr.c	2006-01-21 18:28:17 +0100
@@ -423,6 +427,9 @@ removexattr(struct dentry *d, char __use
 	if (error < 0)
 		return error;
 
+	if (MNT_IS_RDONLY(mnt))
+		return -EROFS;
+
 	return vfs_removexattr(d, kname);
 }
 
--- linux-2.6.16-rc1/fs/xattr.c	2006-01-26 22:35:13 +0100
+++ linux-2.6.16-rc1-vs2.1.0.9.4/fs/xattr.c	2006-01-21 18:28:17 +0100
@@ -435,7 +442,7 @@ sys_removexattr(char __user *path, char 
 	error = user_path_walk(path, &nd);
 	if (error)
 		return error;
-	error = removexattr(nd.dentry, name);
+	error = removexattr(nd.dentry, name, nd.mnt);
 	path_release(&nd);
 	return error;
 }
--- linux-2.6.16-rc1/fs/xattr.c	2006-01-26 22:35:13 +0100
+++ linux-2.6.16-rc1-vs2.1.0.9.4/fs/xattr.c	2006-01-21 18:28:17 +0100
@@ -449,7 +456,7 @@ sys_lremovexattr(char __user *path, char
 	error = user_path_walk_link(path, &nd);
 	if (error)
 		return error;
-	error = removexattr(nd.dentry, name);
+	error = removexattr(nd.dentry, name, nd.mnt);
 	path_release(&nd);
 	return error;
 }
--- linux-2.6.16-rc1/fs/xattr.c	2006-01-26 22:35:13 +0100
+++ linux-2.6.16-rc1-vs2.1.0.9.4/fs/xattr.c	2006-01-21 18:28:17 +0100
@@ -463,7 +470,7 @@ sys_fremovexattr(int fd, char __user *na
 	f = fget(fd);
 	if (!f)
 		return error;
-	error = removexattr(f->f_dentry, name);
+	error = removexattr(f->f_dentry, name, f->f_vfsmnt);
 	fput(f);
 	return error;
 }
--- linux-2.6.16-rc1/include/linux/fs.h	2006-01-26 22:35:19 +0100
+++ linux-2.6.16-rc1-vs2.1.0.9.4/include/linux/fs.h	2006-01-29 16:01:52 +0100
@@ -150,7 +154,7 @@ extern int dir_notify_enable;
  */
 #define __IS_FLG(inode,flg) ((inode)->i_sb->s_flags & (flg))
 
-#define IS_RDONLY(inode) ((inode)->i_sb->s_flags & MS_RDONLY)
+#define IS_RDONLY(inode)	__IS_FLG(inode, MS_RDONLY)
 #define IS_SYNC(inode)		(__IS_FLG(inode, MS_SYNCHRONOUS) || \
 					((inode)->i_flags & S_SYNC))
 #define IS_DIRSYNC(inode)	(__IS_FLG(inode, MS_SYNCHRONOUS|MS_DIRSYNC) || \
--- linux-2.6.16-rc1/include/linux/fs.h	2006-01-26 22:35:19 +0100
+++ linux-2.6.16-rc1-vs2.1.0.9.4/include/linux/fs.h	2006-01-29 16:01:52 +0100
@@ -901,12 +922,12 @@ static inline void unlock_super(struct s
  */
 extern int vfs_permission(struct nameidata *, int);
 extern int vfs_create(struct inode *, struct dentry *, int, struct nameidata *);
-extern int vfs_mkdir(struct inode *, struct dentry *, int);
-extern int vfs_mknod(struct inode *, struct dentry *, int, dev_t);
-extern int vfs_symlink(struct inode *, struct dentry *, const char *, int);
-extern int vfs_link(struct dentry *, struct inode *, struct dentry *);
-extern int vfs_rmdir(struct inode *, struct dentry *);
-extern int vfs_unlink(struct inode *, struct dentry *);
+extern int vfs_mkdir(struct inode *, struct dentry *, int, struct nameidata *);
+extern int vfs_mknod(struct inode *, struct dentry *, int, dev_t, struct nameidata *);
+extern int vfs_symlink(struct inode *, struct dentry *, const char *, int, struct nameidata *);
+extern int vfs_link(struct dentry *, struct inode *, struct dentry *, struct nameidata *);
+extern int vfs_rmdir(struct inode *, struct dentry *, struct nameidata *);
+extern int vfs_unlink(struct inode *, struct dentry *, struct nameidata *);
 extern int vfs_rename(struct inode *, struct dentry *, struct inode *, struct dentry *);
 
 /*
--- linux-2.6.16-rc1/include/linux/mount.h	2006-01-26 22:35:20 +0100
+++ linux-2.6.16-rc1-vs2.1.0.9.4/include/linux/mount.h	2006-01-25 05:34:51 +0100
@@ -22,6 +22,9 @@
 #define MNT_NOEXEC	0x04
 #define MNT_NOATIME	0x08
 #define MNT_NODIRATIME	0x10
+#define MNT_RDONLY	0x20
+
+#define MNT_IS_RDONLY(m)	((m) && ((m)->mnt_flags & MNT_RDONLY))
 
 #define MNT_SHARED	0x1000	/* if the vfsmount is a shared mount */
 #define MNT_UNBINDABLE	0x2000	/* if the vfsmount is a unbindable mount */
--- linux-2.6.16-rc1/include/linux/mount.h	2006-01-26 22:35:20 +0100
+++ linux-2.6.16-rc1-vs2.1.0.9.4/include/linux/mount.h	2006-01-25 05:34:51 +0100
@@ -26,6 +29,7 @@ *****
 #define MNT_SHARED	0x1000	/* if the vfsmount is a shared mount */
 #define MNT_UNBINDABLE	0x2000	/* if the vfsmount is a unbindable mount */
 #define MNT_PNODE_MASK	0x3000	/* propogation flag mask */
+#define MNT_TAGID		0x8000
 
 struct vfsmount {
 	struct list_head mnt_hash;
--- linux-2.6.16-rc1/include/linux/mount.h	2006-01-26 22:35:20 +0100
+++ linux-2.6.16-rc1-vs2.1.0.9.4/include/linux/mount.h	2006-01-25 05:34:51 +0100
@@ -47,6 +51,7 @@ struct vfsmount {
 	struct vfsmount *mnt_master;	/* slave is on master->mnt_slave_list */
 	struct namespace *mnt_namespace; /* containing namespace */
 	int mnt_pinned;
+	tag_t mnt_tag;			/* tagging used for vfsmount */
 };
 
 static inline struct vfsmount *mntget(struct vfsmount *mnt)
--- linux-2.6.16-rc1/ipc/mqueue.c	2006-01-26 22:35:32 +0100
+++ linux-2.6.16-rc1-vs2.1.0.9.4/ipc/mqueue.c	2006-01-21 18:28:17 +0100
@@ -738,7 +747,7 @@ asmlinkage long sys_mq_unlink(const char
 	if (inode)
 		atomic_inc(&inode->i_count);
 
-	err = vfs_unlink(dentry->d_parent->d_inode, dentry);
+	err = vfs_unlink(dentry->d_parent->d_inode, dentry, NULL);
 out_err:
 	dput(dentry);
 
--- linux-2.6.16-rc1/net/unix/af_unix.c	2006-01-26 22:35:40 +0100
+++ linux-2.6.16-rc1-vs2.1.0.9.4/net/unix/af_unix.c	2006-01-25 17:22:11 +0100
@@ -235,6 +238,8 @@ static struct sock *__unix_find_socket_b
 	sk_for_each(s, node, &unix_socket_table[hash ^ type]) {
 		struct unix_sock *u = unix_sk(s);
 
+		if (!vx_check(s->sk_xid, VX_IDENT|VX_WATCH))
+			continue;
 		if (u->addr->len == len &&
 		    !memcmp(u->addr->name, sunname, len))
 			goto found;
--- linux-2.6.16-rc1/net/unix/af_unix.c	2006-01-26 22:35:40 +0100
+++ linux-2.6.16-rc1-vs2.1.0.9.4/net/unix/af_unix.c	2006-01-25 17:22:11 +0100
@@ -781,7 +786,7 @@ static int unix_bind(struct socket *sock
 		 */
 		mode = S_IFSOCK |
 		       (SOCK_INODE(sock)->i_mode & ~current->fs->umask);
-		err = vfs_mknod(nd.dentry->d_inode, dentry, mode, 0);
+		err = vfs_mknod(nd.dentry->d_inode, dentry, mode, 0, NULL);
 		if (err)
 			goto out_mknod_dput;
 		mutex_unlock(&nd.dentry->d_inode->i_mutex);
